var printer = require('printer'),
	_ = require('lodash');

module.exports = function() {
	var BEL = '\x07';
	return {
		print: function(name, data, options, cb) {
			var printOptions = _.extend({
				"cpi": 17,
				"lpi": 9,
				"MediaType": "Custom",
				"PageSize": "X50D8MMY200MM",
				"fit-to-page": true
			}, options || {});

			//console.log("Printing to " + name);
			if (data) {
				return printer.printDirect({
					data: data,
					printer: name,
					options: printOptions,
					type: 'TEXT',
					success: function(jobID) {
						if (cb && _.isFunction(cb)) {
							return cb();
						}
					},
					error: function(err) {
						if (cb && _.isFunction(cb)) {
							return cb(err);
						}
					}
				});
			}
			if (cb) {
				cb("error", "Nothing to print.");
			}
		},
		openDrawer: function(name) {
			//console.log("Opening drawer..");
			return printer.printDirect({
				data: BEL,
				printer: name,
				type: 'RAW',
				success: function() {},
				error: function() {}
			});
		}
	};
};